std::unordered_map::end,(3)

NAME
std::unordered_map::end, - std::unordered_map::end,

Synopsis
   iterator end() noexcept; (since C++11)
   const_iterator end() const noexcept; (since C++11)
   const_iterator cend() const noexcept; (since C++11)
   Returns an iterator to the element following the last element of the unordered_map.
   This element acts as a placeholder; attempting to access it results in undefined
   behavior.
   range-begin-end.svg

Parameters
   (none)

Return value
   Iterator to the element following the last element.

Complexity
   Constant.

Example
// Run this code
 #include <cmath>
 #include <iostream>
 #include <unordered_map>
 struct Node { double x, y; };
 int main() {
     Node nodes[3] = { {1, 0}, {2, 0}, {3, 0} };
     //mag is a map mapping the address of a Node to its magnitude in the plane
     std::unordered_map<Node *, double> mag = {
         { nodes, 1 },
         { nodes + 1, 2 },
         { nodes + 2, 3 }
     };
     //Change each y-coordinate from 0 to the magnitude
     for(auto iter = mag.begin(); iter != mag.end(); ++iter){
         auto cur = iter->first; // pointer to Node
         cur->y = mag[cur]; // could also have used cur->y = iter->second;
     }
     //Update and print the magnitude of each node
     for(auto iter = mag.begin(); iter != mag.end(); ++iter){
         auto cur = iter->first;
         mag[cur] = std::hypot(cur->x, cur->y);
         std::cout << "The magnitude of (" << cur->x << ", " << cur->y << ") is ";
         std::cout << iter->second << '\n';
     }
     //Repeat the above with the range-based for loop
     for(auto i : mag) {
         auto cur = i.first;
         cur->y = i.second;
         mag[cur] = std::hypot(cur->x, cur->y);
         std::cout << "The magnitude of (" << cur->x << ", " << cur->y << ") is ";
         std::cout << mag[cur] << '\n';
         //Note that in contrast to std::cout << iter->second << '\n'; above,
         // std::cout << i.second << '\n'; will NOT print the updated magnitude
     }
 }

Possible output:
 The magnitude of (3, 3) is 4.24264
 The magnitude of (1, 1) is 1.41421
 The magnitude of (2, 2) is 2.82843
 The magnitude of (3, 4.24264) is 5.19615
 The magnitude of (1, 1.41421) is 1.73205
 The magnitude of (2, 2.82843) is 3.4641

See also
   begin returns an iterator to the beginning
   cbegin (public member function)
   (C++11)
   end
   cend returns an iterator to the end of a container or array
   (C++11) (function template)
   (C++14)